#ident "@(#)ex_initiator.c	1.1 04 Jan 1993 SMI"
/*
 * Copyright 1994 Sun Microsystems, Inc. All Rights Reserved
 */

/******************************************************************************/
/***                                                                        ***/
/***  Name : ex_initiator.c                                                 ***/
/***                                                                        ***/
/***  Date : 12 May 93                                                      ***/
/***                                                                        ***/
/***                                                                        ***/
/******************************************************************************/
/***                                                                        ***/
/***  Description :                                                         ***/
/***                                                                        ***/
/******************************************************************************/

/******************************************************************************/
/***                          STANDARD INCLUDE                              ***/
/******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/types.h>

/******************************************************************************/
/***                          PACKAGE INCLUDE                               ***/
/******************************************************************************/
#include <osi_lib.h>
#include <ap_lib.h>

/******************************************************************************/
/***                          USER INCLUDE                                  ***/
/******************************************************************************/
#include "enviro.h"

/******************************************************************************/
/***                          external declaration                          ***/
/******************************************************************************/


/*------------------------------------------------------*/
/* Declaration of default values for API initialisation */
/*------------------------------------------------------*/


/*-------------------------------------------------------*/
/* Declaration of the address of the manager to address  */
/*-------------------------------------------------------*/

/*-----------*/
/* Main call */
/*-----------*/
main(argc, argv)
int	argc;
char	*argv[];
{

int	fd;


/*-------------------------*/
/*  Open a file descriptor */
/*-------------------------*/


printf( "\n\n=============== OPEN DESCRIPTOR ===============\n\n");

if (( fd = OpenApliDescript()) == FAIL )
	exit(0);

/*------------------------*/
/*  Init the environment  */
/*------------------------*/

printf( "\n\n=============== RESPONDER ENVIROMENT INITIALISATION ===============\n\n");
if ( InitApliEnviro ( fd) == FAIL)
   exit (1);


/*---------------------------*/
/* Establish a communication */
/*---------------------------*/
printf( "\n\n=============== CONNECTION  ESTABLISHMENT ===============\n\n");

if ( EstaApliCon ( fd ) == FAIL )
   exit(2); 

/*------------*/
/*  DataXfer  */
/*------------*/
printf( "\n\n=============== DATA TRANSFER ===============\n\n");

if ( DataApliXfer ( fd) == FAIL )
   exit(3);

/*----------------------*/
/* End of communication */
/*----------------------*/

if ( EndApliCom (fd) == FAIL )
   exit(4);

}

/*-----------------------------------------*/
/* Function to open the file descriptor    */
/*-----------------------------------------*/

int OpenApliDescript ()
{
   int	fd;
   char	*descName= "/dev/oopi";
   
   if ((fd = ap_open( descName, NULL) ) == FAIL)
       {
       printf(" Error in ap_open : %s \n",ap_error());
       return ( FAIL);
       }
    return ( fd);
}
     
/*--------------------------------------------------------*/
/*  Function to set the environment for responder side    */
/*--------------------------------------------------------*/

InitApliEnviro ( fd )
int fd;
{
    ap_val_t    val;    /* Value passes to ap_set_env  */
    int         rc;     /* Return code from ap_set_env */
    char 	addr[10]="";

/* initialise the environment (default values) */

printf( "-------> Initialise the environment \n");

if ( ap_init_env( fd, NULL, 0 )!= SUCCESS )
   {
   printf(" Error in ap_init_env : %s \n",ap_error());
   return (FAIL);
   }

/* set the role to responder */

printf( "-------> Set the responder role \n");
val.l = AP_RESPONDER;
if ( (rc = ap_set_env ( fd, AP_ROLE_ALLOWED, val )) != SUCCESS )
   { 
   printf(" Error in ap_set_env AP_ROLE_ALLOWED : %s \n",ap_error());
   return(FAIL);
   } 

 
/* call function to bind local presentation address */

printf( "\n-------> Set the bind address \n");
printf( "             Local Presentation selector       : %s\n",ResPresSel);
printf( "             Local Session selector            : %s\n",ResSesSel);
#ifndef RFC1006
printf( "             Local transport selector          : %s\n",ResTrpSel);
#endif
printf( "             Local Bind NSAP                   : %s\n",ResBindNsap);

if ( set_paddr ( fd, AP_BIND_PADDR, ResPresSel, ResSesSel, ResTrpSel, ResBindNsap ))
   { 
   printf(" Error ap_set_env  AP_BIND_PADDR : %s \n",ap_error());
   return(FAIL);
   } 

/* call function to set remote presentation address */

printf( "\n-------> Set the remote address \n");
printf( "             Local Presentation selector       : %s\n",IniPresSel);
printf( "             Local Session selector            : %s\n",IniSesSel);
#ifndef RFC1006
printf( "             Local transport selector          : %s\n",IniTrpSel);
#endif
printf( "             Local Bind NSAP                   : %s\n",IniBindNsap);

if ( set_paddr ( fd, AP_REM_PADDR, IniPresSel, IniSesSel, IniTrpSel, IniNsap ))
   { 
   printf(" Error ap_set_env  AP_REM_PADDR : %s \n",ap_error());
   return(FAIL);
   } 
 
/* call function to set context name */

printf( "-------> Set the context name \n");

if ( set_cntx_name(fd) )
   { 
   printf(" Error in ap_set_env AP_CTNX: %s \n",ap_error());
   return(FAIL);
   } 
 
return (SUCCESS);
}

/*-------------------------------------*/
/*  Function to establish a connection */
/*-------------------------------------*/
EstaApliCon (fd)
int             fd;
{
   ap_cdata_t  cdata,rcdata;
   struct osi_buf ubuf;
   int  flag= 0;
   unsigned long sptype,state;
   int rc;
   char         msg[128];


   /* Wait and read and A_ASSOC_IND */

   ubuf.maxlen=128;
   ubuf.len=0;
   ubuf.buf =msg;
   rc = ap_rcv ( fd, &sptype, &cdata, &ubuf, &flag);
   if (( rc != 0 ) && ( (!sptype & A_ASSOC_IND)) )
      {  
      printf(" Error in ap_rcv A_ASSOC_IND : %s \n",ap_error());
      ap_error();
      return(FAIL);
      }  
printf( "-------> Receive the A_ASSOC_IND  \n"); 

   /* Prepare different structure to send the A_ASSOC_CNF */
 
   cdata.assoc_rsp.res = AP_ACCEPT;
   cdata.assoc_rsp.diag = 0;
   cdata.assoc_rsp.tokens =
            AP_DATA_TOK_REQ   | AP_SYNCMINOR_TOK_REQ |
            AP_MAJACT_TOK_REQ | AP_RELEASE_TOK_REQ;
   cdata.assoc_rsp.udata_length = 0;
 
    /* Set the pcdl structure before send A_ASSOC_RSP */

printf( "-------> Set the presentation context result list   \n");

    if ( make_pcdrl(fd ))
       { 
       printf(" Error in ap_init_env AP_PCDRL: %s \n",ap_error());
      return(FAIL);
       } 
 
   ubuf.maxlen = 128;
   ubuf.len= 0;
   ubuf.buf= msg;
   flag = 0;
 
printf( "-------> Send the  A_ASSOC_RSP confirmation  \n");

   /* Send the confirmation */

    ubuf.maxlen= 128;
    ubuf.len = 0;
    ubuf.buf = msg;
   rc = ap_snd ( fd, A_ASSOC_RSP, &cdata , &ubuf, flag);
   if ( rc != 0 )
      {  
       printf(" Error in ap_snd A_ASSOC_RSP: %s \n",ap_error());
      return(FAIL);
      }  
 
 
   /**** Test we are in AP_DATAXFER state ****/
 
  rc = ap_get_env(fd, AP_STATE, &state);
  if (( rc != 0 ) && ( state != AP_DATAXFER))
     {
     printf(" Error in ap_get_env AP_STATE : %s \n",ap_error());
     return(FAIL)  ;
     }
 
}
/*-----------------------------------------------*/
/* Function to transfer data from the initiator  */
/*-----------------------------------------------*/
 
DataApliXfer ( fd)
int fd;
{
unsigned char buffer[512];
ap_cdata_t          cdata;
struct osi_buf      ubuf;

int  size;
int flag,rc,sptype;
int i;
int len;
         
/*  Fill the transfer structure    */

ubuf.maxlen=512;
ubuf.len = 0;
ubuf.buf = (char *)buffer;
len = 0;
 
/* Receive the data    */

flag = AP_MORE; 
while ( flag == AP_MORE )
   {
   rc = ap_rcv ( fd, &sptype , &cdata, &ubuf, &flag );
   len = len + ubuf.len;
   ubuf.buf = (char *)&buffer[len];
   ubuf.len = 0;
   }
   
/*  Call function to decode user data  */ 
 
Decode_data(buffer) ;
 
}
 
/*---------------------------------------*/
/* Function to send a disconnect request */
/*---------------------------------------*/
EndApliCom(fd)
int	fd;
{

ap_cdata_t 	cdata;
struct osi_buf 	ubuf;
int		rc;
int		flag;
unsigned char buffer[512];
unsigned long	sptype;


ubuf.maxlen=512;
ubuf.len = 0;
ubuf.buf = (char *)buffer;

   /* Send A_RELEASE_REQ       */

   cdata.release_req.rsn= AP_REL_NORMAL;
   cdata.release_req.udata_length= 0;

   rc = ap_snd ( fd, A_RELEASE_REQ , &cdata, NULL, 0);
   if ( rc != 0 )
      {
      printf("Error in ap_snd A_RELEASE_REQ %s \n", ap_error());
      return(FAIL);
      }
printf("---------> Send A_RELEASE_REQ \n");

 /* Receive A_RELEASE_IND */

 rc = ap_rcv ( fd, &sptype, &cdata, &ubuf, &flag); 
   if (( rc != 0 ) && ( (!sptype & A_RELEASE_IND)) )
      {   
      printf(" Error in ap_rcv A_RELEASE_IND : %s \n",ap_error()); 
      return(FAIL); 
      }  
printf( "-------> Receive the A_RELEASE_IND  \n");


/* Close APLI instance */

    ap_close(fd);
 }
